close all hidden


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%DEBUT DE LA FONCTION PRINCIPALE%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Dfinition des variables globales dans chaque fonction et sous-fonction
% handles : identifiants des objets graphiques (vecteur)
global geo_method handles plot_state booleen Nmc Nbi data FileName R current_plot PathName A_est M_est

global Red Green Blue
% Initialisation des variables
geo_method='nfindr';
plot_state='plot on';
booleen=1;
Nmc=100;
Nbi=33;
R=3;
current_plot=0;

Red=0.75;
Green=0.75;
Blue=0.75;


% Cration de l'objet Figure
handles(1)=figure('units','pixels',...
    'position',[10 50 1582 791],...
    'color',[Red Green Blue],...
    'numbertitle','off',...
    'name','Data analysis',...
    'menubar','none',...
    'tag','interface');


% Cration de l'objet Uicontrol Launch estimate
handles(5)=uicontrol('style','pushbutton',...
    'units','normalized',...
    'position',[0.01 0.02 0.05 0.05],...
    'string','Pre-estimate',...    
    'callback',@estimate_2D,...
    'tag','launch1');
    

% Cration de l'objet Uicontrol text Nmc
handles(9)=uicontrol('style','text',...
    'units','normalized',...
    'position',[0.01 0.75 0.05 0.05],...
    'string','Nmc',...
    'tag','Nmc',...
    'foregroundcolor',[0 0 0],...
    'backgroundcolor',[Red Green Blue]);

% Cration de l'objet Uicontrol Set Nmc
handles(10)=uicontrol('style','edit',...
    'units','normalized',...
    'callback',@set_nmc_2D,...
    'position',[0.01 0.73 0.05 0.05],...
    'string','100',...
    'tag','Nmc');

% Cration de l'objet Uicontrol text Nbi
handles(11)=uicontrol('style','text',...
    'units','normalized',...
    'position',[0.11 0.75 0.05 0.05],...
    'string','Nbi',...
    'tag','Nbi',...
    'foregroundcolor',[0 0 0],...
    'backgroundcolor',[Red Green Blue]);

% Cration de l'objet Uicontrol Set Nbi
handles(12)=uicontrol('style','edit',...
    'units','normalized',...
    'callback',@set_nbi_2D,...
    'position',[0.11 0.73 0.05 0.05],...
    'string','33',...
    'tag','Nbi');

% Cration de l'objet Uicontrol menu method
handles(13)=uicontrol('style','popupmenu',...
    'units','normalized',...
    'position',[0.01 0.855 0.15 0.05],...
     'callback',@set_method_2D,...
     'userdata',[1 2 3],...
     'string','nfindr|vca|from file');

%Creation de la barre des menus

handles(14)=uimenu('label','File');

handles(15)=uimenu(handles(14),'label','Load file',...
            'callback',@load_file);

handles(16)=uimenu(handles(14),'label','Save file');

handles(17)=uimenu(handles(16),'label','Matlab format',...
            'callback',@save_file_mat);

handles(18)=uimenu(handles(16),'label','Text format');

handles(19)=uimenu(handles(18),'label','Spectra',...
            'callback',@save_file_spectra);
        
handles(20)=uimenu(handles(18),'label','Unmixing coefficients',...
            'callback',@save_file_abundance);
        
handles(21)=uimenu(handles(18),'label','Both',...
            'callback',@save_file_both);
        
handles(22)=uimenu('label','Help');

handles(23)=uimenu(handles(22),'label','Help me',...
            'callback','open help.pdf');

% Cration de l'objet Uicontrol text file
handles(24)=uicontrol('style','text',...
    'units','normalized',...
    'position',[0.01 0.93 0.17 0.05],...
    'string','No file loaded',...
    'tag','file',...
    'foregroundcolor',[0 0 0],...
    'backgroundcolor',[Red Green Blue]);

%Cration de l'objet Uicontrol retour
handles(25)=uicontrol('style','push',...
    'units','normalized',...
    'callback','Main_interface',...
    'position',[0.94 0.02 0.05 0.05],...
    'string','Back',...
    'tag','retour');

%Cration de l'objet Uicontrol end
handles(26)=uicontrol('style','push',...
    'units','normalized',...
    'callback','end_programm',...
    'position',[0.98 0.96 0.01 0.02],...
    'string','X',...
    'tag','end');

% Cration de l'objet Uicontrol menu plot
handles(27)=uicontrol('style','popupmenu',...
    'units','normalized',...
    'position',[0.01 0.805 0.15 0.05],...
     'callback',@set_plot_2D,...
     'userdata',[1 2],...
     'string','plot on|plot off');

% Cration de l'objet Uicontrol text R
handles(9)=uicontrol('style','text',...
    'units','normalized',...
    'position',[0.01 0.65 0.05 0.05],...
    'string','Number of sources',...
    'tag','R',...
    'foregroundcolor',[0 0 0],...
    'backgroundcolor',[Red Green Blue]); 
 
 
 % Cration de l'objet Uicontrol Set R
handles(28)=uicontrol('style','edit',...
    'units','normalized',...
    'callback',@set_R_2D,...
    'position',[0.01 0.61 0.05 0.05],...
    'string','3',...
    'tag','R');


 % Cration de l'objet Uicontrol Launch Bayesian unmixing
handles(6)=uicontrol('style','pushbutton',...
    'units','normalized',...
    'visible','off',...
    'position',[0.07 0.02 0.05 0.05],...
    'string','Unmix',...    
    'callback',@Bayesian_unmixing_2D,...
    'tag','launch2');


        % Cration de l'objet Uicontrol >
        handles(998)=uicontrol('style','pushbutton',...
            'units','normalized',...
            'visible','off',...
            'position',[0.92 0.5 0.02 0.02],...
            'string','>',...    
            'callback',@next_plot,...
            'tag','>');

        % Cration de l'objet Uicontrol <
        handles(997)=uicontrol('style','pushbutton',...
            'units','normalized',...
            'visible','off',...
            'position',[0.2 0.5 0.02 0.02],...
            'string','<',...    
            'callback',@previous_plot,...
            'tag','>');
        
            % Creation de l'objet text plot_position
handles(996)=uicontrol('style','text',...
    'units','normalized',...
    'visible','off',...
    'position',[0.5 0.01 0.075 0.075],...
    'string','1/1',...
    'tag','plot_position',...
    'fontsize',20,...
    'foregroundcolor',[0 0 0],...
    'backgroundcolor',[Red Green Blue]);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%FIN DE LA FONCTION PRINCIPALE%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%