close all hidden;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
global geo_method handles plot_state bool_plot Nmc Nbi R RGB sources data Nlines Nsamples Nbands wavelength_unit interleave offset byte_order data_type wavelength FileName PathName
global A_est M_est current_plot handles_subplot T_est matP
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Remarques :
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% - Ordonner les handles
% - Grer les dimensions des fentres secondaires utilises... (notamment
% avec les fonctions "plot_spectra", "plot_all_spectra"...)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Initialisation des paramtres "method" et "plot"
geo_method = 'nfindr';
plot_state = 'plot on';
bool_plot = 1;
Nmc = 100;
Nbi = 33;
R = 3;
RGB = [55 41 12];
sources = [];
M_est = [];
A_est = [];
handles_subplot = [];

% Couleurs du menu
Red = 0.75;
Green = 0.75;
Blue = 0.75;

%% Main window
% Cration de l'objet Figure
handles(1)=figure('units','pixels',...
    'position',[10 50 1582 791],...
    'color',[Red Green Blue],...
    'numbertitle','off',...
    'name','Data analysis',...
    'menubar','none',...
    'tag','interface');

%'position',[10 50 1582 791],...
%% Barre des menus

handles(2)=uimenu('label','File');

handles(3)=uimenu(handles(2),'label','Load image');
        
handles(4)=uimenu(handles(3),'label','envi image',...
    'callback',@load_envi);

handles(5)=uimenu(handles(3),'label','matlab image',...
    'callback',@load_mat_3D);
        

%% Plot spectra

handles(6)=uimenu('label','Plot spectra');

handles(7)=uimenu(handles(6),'label','Plot pixel spectrum',...
    'callback',@plot_spectra);

handles(8)=uimenu(handles(6),'label','Plot all spectra',...
    'callback',@plot_all_spectra);

%% Sub analysis
handles(9) = uimenu('label','Sub-analysis');

handles(10) = uimenu(handles(9),'label','Select area',...
    'callback',@select_area);

%% Cancel sub-analysis

handles(48)=uimenu(handles(9),...
    'visible','off',...
    'callback',@cancel_sub_analysis,...
    'label','Cancel selection');

%% Save results

handles(11)=uimenu('label','Save results');

handles(12)=uimenu(handles(11),'label','Matlab format',...
            'callback',@save_file_mat);

handles(13)=uimenu(handles(11),'label','Text format');

handles(14)=uimenu(handles(13),'label','Spectra',...
            'callback',@save_file_spectra);
        
handles(15)=uimenu(handles(13),'label','Abundance',...
            'callback',@save_file_abundance);
        
handles(16)=uimenu(handles(13),'label','Spectra and abundance',...
            'callback',@save_file_both);
        
%% Help

handles(17)=uimenu('label','Help');

handles(18)=uimenu(handles(17),'label','Help me',...
            'callback','open help.pdf');
        
handles(19)=uicontrol('style','text',...
    'units','normalized',...
    'position',[0 0.93 0.17 0.05],...
    'string','No file loaded.',...
    'tag','file',...
    'foregroundcolor',[0 0 0],...
    'backgroundcolor',[Red Green Blue]);

%% Boutons

%"back" pushbutton 
handles(20)=uicontrol('style','push',...
    'units','normalized',...
    'callback','Main_interface',...
    'position',[0.94 0.02 0.05 0.03],...
    'string','Back',...
    'tag','retour');

%"launch" pushbutton 
handles(21)=uicontrol('style','pushbutton',...
    'units','normalized',...
    'position',[0.001 0.02 0.05 0.05],...
    'string','Pre-estimate',...    
    'callback',@estimate_3D,...
    'tag','bouton+');

% Cration de l'objet Uicontrol Launch Bayesian unmixing
handles(49)=uicontrol('style','pushbutton',...
    'visible','off',...
    'units','normalized',...
    'position',[0.07 0.02 0.05 0.05],...
    'string','Unmix',...    
    'callback',@Bayesian_unmixing_3D,...
    'tag','launch2');

%"close" button 
handles(22)=uicontrol('style','push',...
    'units','normalized',...
    'callback','end_programm',...
    'position',[0.98 0.96 0.01 0.02],...
    'string','X',...
    'tag','end');

%% Panneau de choix des paramtres

handles(23) = uipanel('FontSize',12,...
             'units','normalized',...
             'backgroundcolor',[Red Green Blue],...
             'Position',[.001 .1 .11 .83]);


%% Cration d'un panneau "paramtres d'analyse" (format des donnes,
%couleurs de l'image affiche,...)

handles(26) = uipanel('Parent',handles(23),...
    'Title','Method',...
    'backgroundcolor',[Red Green Blue],...
    'FontSize',12,...
    'Position',[.001 .40 .999 .60]);

handles(24) = uicontrol('parent',handles(23),...
    'visible', 'off',...
    'style', 'pushbutton',...
    'units', 'normalized',...
    'position', [0.15 0.8 0.7 0.04],...
    'string', 'Delete sources',...
    'callback', @delete_sources,...
    'tag', 'delete_sources');
          
% Cration de l'objet Uicontrol text Nmc
handles(27)=uicontrol('parent', handles(26),...
    'style','text',...
    'units','normalized',...
    'position',[0.01 0.5 0.3 0.05],...
    'string','Nmc',...
    'tag','Nmc',...
    'foregroundcolor',[0 0 0],...
    'backgroundcolor',[Red Green Blue]);

% Cration de l'objet Uicontrol Set Nmc
handles(28)=uicontrol('parent', handles(26),...
    'style','edit',...
    'units','normalized',...
    'callback',@set_nmc_3D,...
    'position',[0.69 0.5 0.3 0.05],...
    'string','100',...
    'tag','Nmc');

% Cration de l'objet Uicontrol text Nbi
handles(29)=uicontrol('parent', handles(26),...
    'style','text',...
    'units','normalized',...
    'position',[0.01 0.3 0.3 0.05],...
    'string','Nbi',...
    'tag','Nbi',...
    'foregroundcolor',[0 0 0],...
    'backgroundcolor',[Red Green Blue]);

% Cration de l'objet Uicontrol Set Nbi
handles(30)=uicontrol('parent', handles(26),...
    'style','edit',...
    'units','normalized',...
    'callback',@set_nbi_3D,...
    'position',[0.69 0.3 0.3 0.05],...
    'string','33',...
    'tag','Nbi');

%Cration de l'objet uicontrol text number of sources
handles(31)=uicontrol('parent', handles(26),...
    'style','text',...
    'units','normalized',...
    'position',[0.01 0 0.3 0.2],...
    'string','Number of sources',...
    'tag','R',...
    'foregroundcolor',[0 0 0],...
    'backgroundcolor',[Red Green Blue]);

%Cration de l'objet uicontrol set number of sources
handles(32)=uicontrol('parent', handles(26),...
    'style','edit',...
    'units','normalized',...
    'callback',@set_R_3D,...
    'position',[0.69 0.1 0.3 0.05],...
    'string','3',...
    'tag','R');

% Cration de l'objet Uicontrol menu method
handles(33)=uicontrol('parent', handles(26),...
    'style','popupmenu',...
    'units','normalized',...
    'position',[0.001 0.90 0.999 0.05],...
    'callback',@set_method_3D,...
    'userdata',[1 2 3 4],...
    'string','nfindr|vca|select sources|load sources');
          
%% Paramtres "plot"       

% Boutons de dfilement
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Cration de l'objet Uicontrol >
handles(998)=uicontrol('style','pushbutton',...
    'visible','off',...
    'units','normalized',...
    'position',[0.92 0.5 0.02 0.02],...
    'string','>',...    
    'callback',@next_plot_3D,...
    'tag','>');
% Cration de l'objet Uicontrol <
handles(997)=uicontrol('style','pushbutton',...
    'visible','off',...
    'units','normalized',...
    'position',[0.2 0.5 0.02 0.02],...
    'string','<',...    
    'callback',@previous_plot_3D,...
    'tag','>');
handles(996)=uicontrol('style','text',...
    'visible','off',...
    'units','normalized',...
    'position',[0.5 0.01 0.075 0.075],...
    'tag','plot_position',...
    'fontsize',20,...
    'foregroundcolor',[0 0 0],...
    'backgroundcolor',[0.75 0.75 0.75]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

handles(34)=uipanel('Parent',handles(23),...
    'Title','Display','FontSize',12,...
    'backgroundcolor',[Red Green Blue],...
    'Position',[.001 0 .999 .4]);

% Cration de l'objet Uicontrol menu plot
handles(35)=uicontrol('parent', handles(34),...
    'style','popupmenu',...
    'units','normalized',...
    'position',[0.001 0.8 0.999 0.2],...
    'callback',@set_plot_3D,...
    'userdata',[1 2],...
    'string','plot on|plot off');


%% Uibuttongroup
% Create the button group.
handles(36) = uibuttongroup('parent', handles(34),...
    'selectionchangefcn', @Selection,...
    'Position',[0.001 0.0 .999 0.75]);

%% True color

handles(37) = uicontrol('parent', handles(36),...
    'Style','Radio','String','RGB composition',...
    'units', 'normalized',...
    'position',[0.01 0.85 0.8 0.10]);

handles(38)=uicontrol('parent', handles(36),...
    'visible', 'on',...
    'style','text',...
    'units','normalized',...
    'position',[0.01 0.7 0.15 0.08],...
    'string','R',...
    'tag','R',...
    'foregroundcolor',[0 0 0],...
    'backgroundcolor',[Red Green Blue]);

handles(39) = uicontrol('parent', handles(36),...
    'visible', 'on',...
    'Style','edit','String','55',...
    'callback', @set_RGB,...
    'units', 'normalized',...
    'position',[0.16 0.7 0.14 0.08]); %[0.16 0.05 0.14 0.12]

handles(40)=uicontrol('parent', handles(36),...
    'visible', 'on',...
    'style','text',...
    'units','normalized',...
    'position',[0.36 0.7 0.14 0.08],...
    'string','G',...
    'tag','G',...
    'foregroundcolor',[0 0 0],...
    'backgroundcolor',[Red Green Blue]);

handles(41) = uicontrol('parent', handles(36),...
    'visible', 'on',...
    'Style','edit','String','41',...
    'callback', @set_RGB,...
    'units', 'normalized',...
    'position',[0.50 0.7 0.14 0.08]);

handles(42)=uicontrol('parent', handles(36),...
    'visible', 'on',...
    'style','text',...
    'units','normalized',...
    'position',[0.71 0.7 0.14 0.08],...
    'string','B',...
    'tag','B',...
    'foregroundcolor',[0 0 0],...
    'backgroundcolor',[Red Green Blue]);

handles(43) = uicontrol('parent', handles(36),...
    'visible', 'on',...
    'Style','edit','String','12',...
    'callback', @set_RGB,...
    'units', 'normalized',...
    'position',[0.85 0.7 0.14 0.08]);

%% Grey scale
handles(44) = uicontrol('parent', handles(36),...
    'Style','Radio','String','Grey scale',...
    'units', 'normalized',...
    'position',[0.01 0.53 0.7 0.1]);

handles(45)=uicontrol('parent', handles(36),...
    'visible', 'off',...
    'style','text',...
    'units','normalized',...
    'position',[0.01 0.40 0.15 0.08],...
    'string','G',...
    'tag','G',...
    'foregroundcolor',[0 0 0],...
    'backgroundcolor',[Red Green Blue]);

handles(46) = uicontrol('parent', handles(36),...
    'visible', 'off',...
    'Style','edit','String','55',...
    'callback', @set_grey_scale,...
    'units', 'normalized',...
    'position',[0.16 0.40 0.3 0.08]);

%% "Display" button

handles(47)=uicontrol('parent', handles(36),...
    'visible','on',...
    'style','push',...
    'units','normalized',...
    'callback','display_image',...
    'position',[0.2 .01 0.45 0.2],...
    'string','Display',...
    'tag','end');
         
clear Re G B